#include <iostream>

using namespace std;

long long WyznaczPozycjePinezki(
    long long K,
    long long dlugosc_odcinka,
    long long liczba_pinezek) {
  // Jeżeli odcinek ma długość 1, to znaleźliśmy odpowiedź, zwróć K.
  if (dlugosc_odcinka == 1) return K;
  // W przeciwnym wypadku musimy zejść poziom niżej,
  // zatem odpowiednio zmniejszamy liczbę pinezek i długość odcinka.
  long long pinezki_w_czesci = liczba_pinezek / 2;
  long long dlugosc_czesci_odcinka = dlugosc_odcinka / 3;
  // Sprawdzamy w której części jesteśmy, jeżeli po lewej to po prostu
  // wywołujemy się rekurencyjnie z mniejszymi wartościami.
  if (K < pinezki_w_czesci)
    return WyznaczPozycjePinezki(K, dlugosc_czesci_odcinka, pinezki_w_czesci);
  // Natomiast jeżeli po prawej, to musimy dodać pinezki z lewej strony.
  else
    return 2*dlugosc_czesci_odcinka +
      WyznaczPozycjePinezki(K-pinezki_w_czesci, dlugosc_czesci_odcinka,
                            pinezki_w_czesci);
}

int main() {
  int N, Q;
  cin >> N >> Q;
  long long dlugosc_odcinka = 1;
  for (int i=0; i<N; i++) dlugosc_odcinka *= 3;
  long long liczba_pinezek = 2;
  for (int i=0; i<N; i++) liczba_pinezek *= 2;
  while(Q--) {
    long long K;
    cin >> K;
    // Jeżeli K jest większe od liczby pinezek na odcinku, zwróć NIE.
    if (K > liczba_pinezek) cout << "NIE\n";
    else {
      long long ret = WyznaczPozycjePinezki(K-1, dlugosc_odcinka,
                                            liczba_pinezek);
      cout << ret << "\n";
    }
  }
}
